Option Explicit

'******************************************************************************************************
'Dichiarazioni tipi, costanti e funzioni per chiamare la finestra di scelta colori
'Struttura CHOOSECOLOR: contiene tutte le infromazioni sul colore scelto
Public Type CHOOSECOLOR
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    rgbResult As Long
    lpCustColors As String
    flags As Long
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

'Costanti per il membro "flags" di CHOOSECOLOR
Public Const CC_ANYCOLOR = &H100             'Allow the user to select any color.
Public Const CC_ENABLEHOOK = &H10            'Use the hook function specified by lpfnHook to process the _
                                              Choose Color box's messages.
Public Const CC_ENABLETEMPLATE = &H20        'Use the dialog box template identified by hInstance and lpTemplateName.
Public Const CC_ENABLETEMPLATEHANDLE = &H40  'Use the preloaded dialog box template identified by hInstance, _
                                              ignoring lpTemplateName.
Public Const CC_FULLOPEN = &H2               'Automatically display the Define Custom Colors half of the dialog box.
Public Const CC_PREVENTFULLOPEN = &H4        'Disable the button that displays the Define Custom Colors half of the dialog box.
Public Const CC_RGBINIT = &H1                'Make the color specified by rgbResult be the initially selected color.
Public Const CC_SHOWHELP = &H8               'Display the Help button.
Public Const CC_SOLIDCOLOR = &H80            'Only allow the user to select solid colors. If the user attempts to select _
                                              a non-solid color, convert it to the closest solid color.

'Funzione CHOOSECOLOR
Public Declare Function CHOOSECOLOR Lib "comdlg32.dll" _
    Alias "ChooseColorA" (pChoosecolor As CHOOSECOLOR) As Long


'******************************************************************************************************
'Dichiarazioni tipi, costanti e funzioni per chiamare la finestra di scelta fonts
Public Const CF_PRINTERFONTS = &H2
Public Const CF_SCREENFONTS = &H1
Public Const CF_BOTH = (CF_SCREENFONTS Or CF_PRINTERFONTS)
Public Const CF_EFFECTS = &H100
Public Const CF_FORCEFONTEXIST = &H10000
Public Const CF_INITTOLOGFONTSTRUCT = &H40
Public Const CF_LIMITSIZE = &H2000
Public Const CF_NOSIZESEL = &H200000
Public Const CF_SIZEMIN = 8
Public Const CF_SIZEMAX = 72
Public Const BOLD_FONTTYPE = &H100
Public Const ITALIC_FONTTYPE = &H200
Public Const PRINTER_FONTTYPE = &H4000
Public Const REGULAR_FONTTYPE = &H400
Public Const SCREEN_FONTTYPE = &H2000
Public Const SIMULATED_FONTTYPE = &H8000

Public Type LOGFONT
        lfHeight As Long
        lfWidth As Long
        lfEscapement As Long
        lfOrientation As Long
        lfWeight As Long
        lfItalic As Byte
        lfUnderline As Byte
        lfStrikeOut As Byte
        lfCharSet As Byte
        lfOutPrecision As Byte
        lfClipPrecision As Byte
        lfQuality As Byte
        lfPitchAndFamily As Byte
        lfFaceName As String * 31
End Type

Public Type CHOOSEFONT
        lStructSize As Long
        hwndOwner As Long                   'Caller's window handle
        hDC As Long                         'Printer DC/IC or NULL
        lpLogFont As Long                   'Pointer to a LOGFONT struct
        iPointSize As Long                  'Size in points (*10) of selected font
        flags As Long                       'Enum. type flags
        rgbColors As Long                   'Returned text color
        lCustData As Long                   'Data passed to hook function
        lpfnHook As Long                    'Pointer to hook function
        lpTemplateName As String            'Custom template name
        hInstance As Long                   'Instance handle of.EXE that contains custom dialog template
        lpszStyle As String                 'Return the style field here must be LF_FACESIZE or bigger
        nFontType As Integer                'Same value reported to the EnumFonts
                                            'Call back with the extra FONTTYPE bits added
        MISSING_ALIGNMENT As Integer
        nSizeMin As Long                    'Minimum pt size allowed &
        nSizeMax As Long                    'Max pt size allowed if CF_LIMITSIZE is used
End Type

Public Declare Function CHOOSEFONT Lib "comdlg32.dll" _
        Alias "ChooseFontA" (pChoosefont As CHOOSEFONT) As Long
Public Declare Sub CopyMemory Lib "kernel32" _
        Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
Public Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Public Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long
Public Declare Function GlobalAlloc Lib "kernel32" (ByVal wFlags As Long, ByVal dwBytes As Long) As Long
Public Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long


'******************************************************************************************************
'Dichiarazioni tipi, costanti e funzioni per chiamare la finestra di scelta files
Public Const OFN_FILEMUSTEXIST = &H1000
Public Const OFN_HIDEREADONLY = &H4
Public Const OFN_PATHMUSTEXIST = &H800

Public Type OPENFILENAME
    lStructSize As Long
    hwndOwner As Long
    hInstance As Long
    lpstrFilter As String
    lpstrCustomFilter As String
    nMaxCustomFilter As Long
    nFilterIndex As Long
    lpstrFile As String
    nMaxFile As Long
    lpstrFileTitle As String
    nMaxFileTitle As Long
    lpstrInitialDir As String
    lpstrTitle As String
    flags As Long
    nFileOffset As Integer
    nFileExtension As Integer
    lpstrDefExt As String
    lCustData As Long
    lpfnHook As Long
    lpTemplateName As String
End Type

Public Declare Function GetOpenFileName Lib "comdlg32.dll" _
        Alias "GetOpenFileNameA" (lpofn As OPENFILENAME) As Long
