'******************************************************************************************************
'Mostra la common dialog di scelta dei colori
Public Function ShowColor(frm As Form, initColor As Long) As Long
    Dim cc As CHOOSECOLOR, CustColor(16) As Long, lReturn As Long, CustomColors As String
    cc.rgbResult = initColor
    cc.lStructSize = Len(cc)
    cc.hwndOwner = frm.hWnd
    cc.lpCustColors = StrConv(CustomColors, vbUnicode)
    cc.flags = CC_FULLOPEN + CC_RGBINIT
    If CHOOSECOLOR(cc) <> 0 Then
        ShowColor = cc.rgbResult
        CustomColors = StrConv(cc.lpCustColors, vbFromUnicode)
    Else
        ShowColor = -1
    End If
End Function

'******************************************************************************************************
'Mostra la common dialog di scelta dei caratteri
Public Sub ShowFont(frm As Form, cf As CHOOSEFONT, lf As LOGFONT)
    Dim hMem As Long, pMem As Long, RetVal As Long
    lf.lfEscapement = 0                                 'Angle between baseline and escapement vector
    lf.lfOrientation = 0                                'Angle between baseline and orientation vector
    lf.lfCharSet = DEFAULT_CHARSET                      'Use default character set
    lf.lfOutPrecision = OUT_DEFAULT_PRECIS              'Default precision mapping
    lf.lfClipPrecision = CLIP_DEFAULT_PRECIS            'Default clipping precision
    lf.lfQuality = DEFAULT_QUALITY                      'Default quality setting
    lf.lfPitchAndFamily = DEFAULT_PITCH Or FF_ROMAN     'Default pitch, proportional with serifs
    'Create the memory block which will act as the LOGFONT structure buffer.
    hMem = GlobalAlloc(GMEM_MOVEABLE Or GMEM_ZEROINIT, Len(lf))
    pMem = GlobalLock(hMem)                             'Lock and get pointer
    CopyMemory ByVal pMem, lf, Len(lf)                  'Copy structure's contents into block
    cf.lStructSize = Len(cf)                            'Size of structure
    cf.hwndOwner = frm.hWnd                             'Handler of the form is opening this dialog box
    cf.lpLogFont = pMem                                 'Pointer to LOGFONT memory block buffer
    cf.flags = CF_SCREENFONTS Or CF_EFFECTS Or CF_LIMITSIZE Or CF_INITTOLOGFONTSTRUCT Or CF_FORCEFONTEXIST
    cf.nFontType = REGULAR_FONTTYPE                     'Regular font type i.e. not bold or anything
    cf.nSizeMin = CF_SIZEMIN                            'Minimum point size
    cf.nSizeMax = CF_SIZEMAX                            'Maximum point size
    RetVal = CHOOSEFONT(cf)                             'Open the dialog box
    If RetVal <> 0 Then                                 'Open successfully
        CopyMemory lf, ByVal pMem, Len(lf)              'Copy memory back
        Debug.Print                                     'End the line
    End If
    'Deallocate the memory block
    RetVal = GlobalUnlock(hMem)                     'Destroy pointer, unlock block
    RetVal = GlobalFree(hMem)                       'Free the allocated memory
End Sub

Public Sub ShowFile(frm As Form, fb As OPENFILENAME)
    Dim fName As String
    Dim result As Long
    Dim path As String
    path = "C:\"
    With fb
        .lStructSize = Len(fb)                      'Size of the structure
        .hwndOwner = frm.hWnd                       'Handle to window opening the dialog
        .hInstance = 0                              'Handle to calling instance (not needed)
        .lpstrFilter = "Tutti i File (*.*)" & vbNullChar & "*.*" & vbNullChar
                        '& "BMP Files (*.bmp)" & vbNullChar & "*.bmp" & vbNullChar _
                        '& "GIF Files (*.gif)" & vbNullChar & "*.bmp" & vbNullChar _
                        '& "JPG Files (*.jpg)" & vbNullChar & "*.bmp" & vbNullChar & vbNullChar
        '.lpstrCustomFilter is ignored -- unused string
        .nMaxCustomFilter = 0
        .nFilterIndex = 1                           'Default filter is the first one (Text Files, in this case)
        .lpstrFile = Space(256) & vbNullChar        'No default filename. Also make room for received path and _
                                                     filename of the user's selection.
        .nMaxFile = Len(.lpstrFile)
        .lpstrFileTitle = Space(256) & vbNullChar   'Make room for filename of the user's selection
        .nMaxFileTitle = Len(.lpstrFileTitle)
        .lpstrInitialDir = path & vbNullChar        'Initial directory is C:\
        .lpstrTitle = "Scelta File" & vbNullChar    'Title of file dialog
        .flags = OFN_PATHMUSTEXIST Or OFN_FILEMUSTEXIST Or OFN_HIDEREADONLY
        .nFileOffset = 0                            'The rest of the options aren't needed.
        .nFileExtension = 0
        '.lpstrDefExt is ignored -- unused string
        .lCustData = 0
        .lpfnHook = 0
        '.lpTemplateName is ignored -- unused string
    End With
    result = GetOpenFileName(fb)
    If result <> 0 Then
        fName = Left(fb.lpstrFile, InStr(fb.lpstrFile, vbNullChar) - 1)
    End If
End Sub
